## patool 1.3

=== Makefile ===
# This Makefile is only used by developers.
PYTHON:=python
VERSION:=$(shell $(PYTHON) setup.py --version)
MAINTAINER:=$(shell $(PYTHON) setup.py --maintainer)
AUTHOR:=$(shell $(PYTHON) setup.py --author)
APPNAME:=$(shell $(PYTHON) setup.py --name)
LAPPNAME:=$(shell echo $(APPNAME)|tr "[A-Z]" "[a-z]")
ARCHIVE_SOURCE:=$(LAPPNAME)-$(VERSION).tar.gz
ARCHIVE_WIN32:=$(LAPPNAME)-$(VERSION).exe
GITUSER:=wummel
GITREPO:=$(LAPPNAME)
WEBPAGE:=$(HOME)/public_html/patool-webpage.git
WEBMETA:=doc/web/app.yaml
DEBUILDDIR:=$(HOME)/projects/debian/official
DEBORIGFILE:=$(DEBUILDDIR)/$(LAPPNAME)_$(VERSION).orig.tar.gz
DEBPACKAGEDIR:=$(DEBUILDDIR)/$(LAPPNAME)-$(VERSION)
# Pytest options:
# --resultlog: write test results in file
# -s: do not capture stdout/stderr (some tests fail otherwise)
PYTESTOPTS?=--resultlog=testresults.txt -s
# which test modules to run
TESTS ?= tests/
# set test options
TESTOPTS=

all:


dist:
	[ -d dist ] || mkdir dist
	git archive --format=tar --prefix=$(LAPPNAME)-$(VERSION)/ HEAD | gzip -9 > dist/$(ARCHIVE_SOURCE)
	[ ! -f ../$(ARCHIVE_WIN32) ] || cp ../$(ARCHIVE_WIN32) dist

sign:
	[ -f dist/$(ARCHIVE_SOURCE).asc ] || gpg --detach-sign --armor dist/$(ARCHIVE_SOURCE)
	[ -f dist/$(ARCHIVE_WIN32).asc ] || gpg --detach-sign --armor dist/$(ARCHIVE_WIN32)

upload:
	cp dist/$(ARCHIVE_SOURCE) dist/$(ARCHIVE_WIN32) \
	  dist/$(ARCHIVE_SOURCE).asc dist/$(ARCHIVE_WIN32).asc \
	  $(WEBPAGE)/dist

homepage:
# update metadata
	@echo "version: \"$(VERSION)\"" > $(WEB_META)
	@echo "name: \"$(APPNAME)\"" >> $(WEB_META)
	@echo "lname: \"$(LAPPNAME)\"" >> $(WEB_META)
	@echo "maintainer: \"$(MAINTAINER)\"" >> $(WEB_META)
	@echo "author: \"$(AUTHOR)\"" >> $(WEB_META)
	git add $(WEB_META)
	git cm "Updated web meta data."
# relase website
	$(MAKE) -C doc/web release

tag:
# add and push the version tag
	git tag upstream/$(VERSION)
	git push --tags origin upstream/$(VERSION)

# Make a new release by calling all the distinct steps in the correct order.
# Each step is a separate target so that it's easy to do this manually if
# anything screwed up.
release: clean releasecheck
	$(MAKE) dist sign upload homepage tag register changelog deb

register:
	@echo "Register at Python Package Index..."
	$(PYTHON) setup.py register
	@echo "Submitting to freecode.org..."
	freecode-submit < $(LAPPNAME).freecode

releasecheck: test check
	@if egrep -i "xx\.|xxxx|\.xx" doc/changelog.txt > /dev/null; then \
	  echo "Could not release: edit doc/changelog.txt release date"; false; \
	fi
	@if [ ! -f ../$(ARCHIVE_WIN32) ]; then \
	  echo "Missing WIN32 distribution archive at ../$(ARCHIVE_WIN32)"; \
	  false; \
	fi
	@if ! grep "Version: $(VERSION)" $(LAPPNAME).freecode > /dev/null; then \
	  echo "Could not release: edit $(LAPPNAME).freecode version"; false; \
	fi

check:
# The check programs used here are mostly local scripts on my private system.
# So for other developers there is no need to execute this target.
	check-copyright
	check-pofiles -v
	py-tabdaddy
	py-unittest2-compat tests/
	$(MAKE) doccheck

doccheck:
	py-check-docstrings --force \
	  patoolib \
	  patool \
	  *.py

pyflakes:
	pyflakes setup.py patool patoolib tests

count:
# print some code statistics
	@sloccount patool patoolib

clean:
	find . -name \*.pyc -delete
	find . -name \*.pyo -delete
	rm -rf build dist

localbuild:
	$(PYTHON) setup.py build

test:	localbuild
	$(PYTHON) -m pytest $(PYTESTOPTS) $(TESTOPTS) $(TESTS)

doc/$(LAPPNAME).txt: doc/$(LAPPNAME).1
# make text file from man page for Windows builds
	cols=`stty size | cut -d" " -f2`; stty cols 72; man -l $< | sed -e 's/.\cH//g' > $@; stty cols $$cols

deb:
# build a debian package
	[ -f $(DEBORIGFILE) ] || cp dist/$(ARCHIVE_SOURCE) $(DEBORIGFILE)
	sed -i -e 's/VERSION_$(LAPPNAME):=.*/VERSION_$(LAPPNAME):=$(VERSION)/' $(DEBUILDDIR)/$(LAPPNAME).mak
	[ -d $(DEBPACKAGEDIR) ] || (cd $(DEBUILDDIR); \
	  patool extract $(DEBORIGFILE); \
	  cd $(CURDIR); \
	  git checkout debian; \
	  cp -r debian $(DEBPACKAGEDIR); \
	  rm -f $(DEBPACKAGEDIR)/debian/.gitignore; \
	  git checkout master)
	$(MAKE) -C $(DEBUILDDIR) $(LAPPNAME)_clean $(LAPPNAME)

update-copyright:
# update-copyright is a local tool which updates the copyright year for each
# modified file.
	update-copyright --holder="$(MAINTAINER)"

changelog:
# github-changelog is a local tool which parses the changelog and automatically
# closes issues mentioned in the changelog entries.
	github-changelog $(DRYRUN) $(GITUSER) $(GITREPO) doc/changelog.txt

.PHONY: changelog update-copyright deb test clean count pyflakes check
.PHONY: releasecheck release upload sign dist all tag register homepage
.PHONY: localbuild doccheck

=== debian/changelog ===
patool (1.3-1) unstable; urgency=low

  * New upstream release.

 -- Bastian Kleineidam <calvin@debian.org>  Fri, 19 Jul 2013 15:11:17 +0200

patool (1.2-1) unstable; urgency=low

  * New upstream release.
    (Closes: #711959)

 -- Bastian Kleineidam <calvin@debian.org>  Thu, 27 Jun 2013 22:20:13 +0200

patool (1.1-1) unstable; urgency=low

  * New upstream release.

 -- Bastian Kleineidam <calvin@debian.org>  Sun, 14 Apr 2013 14:41:58 +0200

patool (1.0-2) unstable; urgency=low

  * Start with a clean debian/changelog.
  * Remove unofficial remark from debian/control
  * Do not install custom bts file for reportbug.
  * Use machine-readable debian/copyright information.

 -- Bastian Kleineidam <calvin@debian.org>  Tue, 05 Mar 2013 19:44:45 +0100

patool (1.0-1) unstable; urgency=low

  * Official release (Closes: #702029)

 -- Bastian Kleineidam <calvin@debian.org>  Mon, 04 Mar 2013 19:12:32 +0100

=== debian/watch ===
# watch control file for uscan
version=3
http://wummel.github.io/patool/ \
  http://github.io/downloads/wummel/patool/patool-(.*).tar.gz

## patool 1.4

=== Makefile ===
--- 
+++ 
@@ -42,12 +42,12 @@
 
 homepage:
 # update metadata
-	@echo "version: \"$(VERSION)\"" > $(WEB_META)
-	@echo "name: \"$(APPNAME)\"" >> $(WEB_META)
-	@echo "lname: \"$(LAPPNAME)\"" >> $(WEB_META)
-	@echo "maintainer: \"$(MAINTAINER)\"" >> $(WEB_META)
-	@echo "author: \"$(AUTHOR)\"" >> $(WEB_META)
-	git add $(WEB_META)
+	@echo "version: \"$(VERSION)\"" > $(WEBMETA)
+	@echo "name: \"$(APPNAME)\"" >> $(WEBMETA)
+	@echo "lname: \"$(LAPPNAME)\"" >> $(WEBMETA)
+	@echo "maintainer: \"$(MAINTAINER)\"" >> $(WEBMETA)
+	@echo "author: \"$(AUTHOR)\"" >> $(WEBMETA)
+	git add $(WEBMETA)
 	git cm "Updated web meta data."
 # relase website
 	$(MAKE) -C doc/web release

=== requirements.txt ===
# no other Python packages needed

=== debian/changelog ===
patool (1.4-2) unstable; urgency=low

  * Updated debian/watch

 -- Bastian Kleineidam <calvin@debian.org>  Wed, 15 Jan 2014 20:05:45 +0100

patool (1.4-1) unstable; urgency=low

  * New upstream release.

 -- Bastian Kleineidam <calvin@debian.org>  Fri, 26 Jul 2013 22:39:17 +0200

=== debian/control ===
Source: patool
Section: utils
Priority: optional
Maintainer: Bastian Kleineidam <calvin@debian.org>
Build-Depends: python-all (>= 2.7), debhelper (>= 9)
X-Python-Version: >= 2.7
Standards-Version: 3.9.4
Homepage: http://wummel.github.io/patool/

Package: patool
Architecture: all
Depends: ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
Recommends: file
Provides: ${python:Provides}
Suggests: arj, bzip2 | lbzip2 | pbzip2, cabextract | lcab, ncompress,
  cpio | bsdcpio, lzop, p7zip-full, rar | unrar | unrar-nonfree, zip | unzip,
  rpm2cpio, binutils, lha, unace | unace-nonfree, arc | nomarch, unalz,
  lrzip (>= 0.551), tar (>= 1.26) | star | bsdtar, rzip, zoo, xdms, orange,
  lzip | plzip | clzip | pdlzip, sharutils, flac, shorten, unadf, archmage,
  genisoimage, python-argcomplete
Description: command line archive file manager
 Various archive formats can be created, extracted, tested, listed,
 compared, searched and repacked by patool. The archive format is
 determined with file(1) and as a fallback by the archive file extension.
 .
 patool supports 7z (.7z), ACE (.ace), ADF (.adf), ALZIP (.alz), AR (.a),
 ARC (.arc), ARJ (.arj), BZIP2 (.bz2), CAB (.cab), compress (.Z), CPIO (.cpio),
 DEB (.deb), DMS (.dms), FLAC (.flac), GZIP (.gz), ISO (.iso), LZH (.lha, .lzh),
 LZIP (.lz), LZMA (.lzma), LZOP (.lzo), RAR (.rar), RPM (.rpm), RZIP (.rz),
 SHAR (.shar), SHN (.shn), TAR (.tar), XZ (.xz), ZIP (.zip, .jar) and
 ZOO (.zoo) formats.
 .
 It relies on helper applications to handle those archive formats
 (for example bzip2 for BZIP2 archives).
 .
 The archive formats TAR, ZIP, BZIP2 and GZIP
 are supported natively and do not require helper applications to be
 installed.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with python2

override_dh_auto_build:
# force usage of setup.py over Makefile
	dh_auto_build --buildsystem python_distutils
	$(MAKE) doc/patool.txt

# do not run test suite when building
override_dh_auto_test:

override_dh_installchangelogs:
# install custom changelog
	dh_installchangelogs doc/changelog.txt

ROOT=$(CURDIR)/debian/patool

override_dh_auto_install:
	dh_auto_install --buildsystem python_distutils
# install bash_completion script
	install -m 644 patool.bash-completion $(ROOT)/etc/bash_completion.d/patool

# use xz for debian binary package compression
override_dh_builddeb:
	dh_builddeb -- -Zxz

=== debian/watch ===
# patool-(.*)\.tar\.gz
# watch control file for uscan
version=3
http://wummel.github.io/patool/ \
  http://wummel\.github\.io/patool/dist/patool-(.*)\.tar\.gz

## patool 1.7

=== Makefile ===
# This Makefile is only used by developers.
PYTHON:=python
VERSION:=$(shell $(PYTHON) setup.py --version)
MAINTAINER:=$(shell $(PYTHON) setup.py --maintainer)
AUTHOR:=$(shell $(PYTHON) setup.py --author)
APPNAME:=$(shell $(PYTHON) setup.py --name)
ARCHIVE_SOURCE:=$(APPNAME)-$(VERSION).tar.gz
ARCHIVE_WIN32:=$(APPNAME)-$(VERSION).exe
GITUSER:=wummel
GITREPO:=$(APPNAME)
HOMEPAGE:=$(HOME)/public_html/patool-webpage.git
WEBMETA:=doc/web/app.yaml
DEBUILDDIR:=$(HOME)/projects/debian/official
DEBORIGFILE:=$(DEBUILDDIR)/$(APPNAME)_$(VERSION).orig.tar.gz
DEBPACKAGEDIR:=$(DEBUILDDIR)/$(APPNAME)-$(VERSION)
# Pytest options:
# --resultlog: write test results in file
# -s: do not capture stdout/stderr (some tests fail otherwise)
PYTESTOPTS?=--resultlog=testresults.txt -s
# which test modules to run
TESTS ?= tests/
# set test options
TESTOPTS=

all:


dist:
	[ -d dist ] || mkdir dist
	$(PYTHON) setup.py sdist --formats=tar
	gzip --best dist/$(APPNAME)-$(VERSION).tar
	[ ! -f ../$(ARCHIVE_WIN32) ] || cp ../$(ARCHIVE_WIN32) dist

sign:
	[ -f dist/$(ARCHIVE_SOURCE).asc ] || gpg --detach-sign --armor dist/$(ARCHIVE_SOURCE)
	[ -f dist/$(ARCHIVE_WIN32).asc ] || gpg --detach-sign --armor dist/$(ARCHIVE_WIN32)

upload:	upload_source upload_binary

upload_source:
	twine upload dist/$(ARCHIVE_SOURCE) dist/$(ARCHIVE_SOURCE).asc

upload_binary:
	cp dist/$(ARCHIVE_WIN32) dist/$(ARCHIVE_WIN32).asc \
	  $(HOMEPAGE)/dist

update_webmeta:
# update metadata
	@echo "version: \"$(VERSION)\"" > $(WEBMETA)
	@echo "name: \"$(APPNAME)\"" >> $(WEBMETA)
	@echo "maintainer: \"$(MAINTAINER)\"" >> $(WEBMETA)
	@echo "author: \"$(AUTHOR)\"" >> $(WEBMETA)
	git add $(WEBMETA)
	git cm "Updated web meta data."

homepage: update_webmeta
# relase website
	$(MAKE) -C doc/web release

tag:
# add and push the version tag
	git tag upstream/$(VERSION)
	git push --tags origin upstream/$(VERSION)

# Make a new release by calling all the distinct steps in the correct order.
# Each step is a separate target so that it's easy to do this manually if
# anything screwed up.
release: distclean releasecheck
	$(MAKE) dist sign upload homepage tag register changelog deb

register:
	@echo "Register at Python Package Index..."
	$(PYTHON) setup.py register

releasecheck: test check
	@if egrep -i "xx\.|xxxx|\.xx" doc/changelog.txt > /dev/null; then \
	  echo "Could not release: edit doc/changelog.txt release date"; false; \
	fi
	@if [ ! -f ../$(ARCHIVE_WIN32) ]; then \
	  echo "Missing WIN32 distribution archive at ../$(ARCHIVE_WIN32)"; \
	  false; \
	fi
	$(PYTHON) setup.py check --restructuredtext

check:
# The check programs used here are mostly local scripts on my private system.
# So for other developers there is no need to execute this target.
	check-copyright
	check-pofiles -v
	py-tabdaddy
	py-unittest2-compat tests/
	$(MAKE) doccheck

doccheck:
	py-check-docstrings --force \
	  patoolib \
	  patool \
	  *.py

pyflakes:
	pyflakes setup.py patool patoolib tests

count:
# print some code statistics
	@sloccount patool patoolib

clean:
	-$(PYTHON) setup.py clean --all
	find . -name '*.py[co]' -exec rm -f {} \;

distclean:	clean
	rm -rf build dist $(APPNAME).egg-info
	rm -f _$(APPNAME)_configdata.py MANIFEST
# clean aborted dist builds and output files
	rm -f testresults.txt
	rm -rf $(APPNAME)-$(VERSION)
	rm -f *-stamp*

localbuild:
	$(PYTHON) setup.py build

test:	localbuild
	$(PYTHON) -m pytest $(PYTESTOPTS) $(TESTOPTS) $(TESTS)

doc/$(APPNAME).txt: doc/$(APPNAME).1
# make text file from man page for Windows builds
	cols=`stty size | cut -d" " -f2`; stty cols 72; man -l $< | sed -e 's/.\cH//g' > $@; stty cols $$cols

deb:
# build a debian package
	[ -f $(DEBORIGFILE) ] || cp dist/$(ARCHIVE_SOURCE) $(DEBORIGFILE)
	sed -i -e 's/VERSION_$(APPNAME):=.*/VERSION_$(LAPPNAME):=$(VERSION)/' $(DEBUILDDIR)/$(LAPPNAME).mak
	[ -d $(DEBPACKAGEDIR) ] || (cd $(DEBUILDDIR); \
	  patool extract $(DEBORIGFILE); \
	  cd $(CURDIR); \
	  git checkout debian; \
	  cp -r debian $(DEBPACKAGEDIR); \
	  rm -f $(DEBPACKAGEDIR)/debian/.gitignore; \
	  git checkout master)
	$(MAKE) -C $(DEBUILDDIR) $(APPNAME)_clean $(APPNAME)

update-copyright:
# update-copyright is a local tool which updates the copyright year for each
# modified file.
	update-copyright --holder="$(MAINTAINER)"

changelog:
# github-changelog is a local tool which parses the changelog and automatically
# closes issues mentioned in the changelog entries.
	github-changelog $(DRYRUN) $(GITUSER) $(GITREPO) doc/changelog.txt

.PHONY: changelog update-copyright deb test clean count pyflakes check
.PHONY: releasecheck release upload sign dist all tag register homepage
.PHONY: localbuild doccheck

=== debian/changelog ===
patool (1.7-1~nd13.10+1) saucy; urgency=low

  * Backported for saucy.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Tue, 07 Oct 2014 00:08:40 -0400

patool (1.7-1) unstable; urgency=low

  * New upstream release.

 -- Bastian Kleineidam <calvin@debian.org>  Fri, 27 Jun 2014 18:00:38 +0200

patool (1.6-1) unstable; urgency=low

  * New upstream release.

 -- Bastian Kleineidam <calvin@debian.org>  Sun, 08 Jun 2014 12:36:42 +0200

patool (1.5-1) unstable; urgency=low

  * New upstream release.

 -- Bastian Kleineidam <calvin@debian.org>  Sun, 30 Mar 2014 08:34:41 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: patool
 Section: utils
 Priority: optional
-Maintainer: Bastian Kleineidam <calvin@debian.org>
+Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
+X-Original-Maintainer: Bastian Kleineidam <calvin@debian.org>
 Build-Depends: python-all (>= 2.7), debhelper (>= 9)
 X-Python-Version: >= 2.7
 Standards-Version: 3.9.4
@@ -9,7 +10,7 @@
 
 Package: patool
 Architecture: all
-Depends: ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
+Depends: neurodebian-popularity-contest, ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
 Recommends: file
 Provides: ${python:Provides}
 Suggests: arj, bzip2 | lbzip2 | pbzip2, cabextract | lcab, ncompress,

## patool 1.10

=== Makefile ===
--- 
+++ 
@@ -5,14 +5,11 @@
 AUTHOR:=$(shell $(PYTHON) setup.py --author)
 APPNAME:=$(shell $(PYTHON) setup.py --name)
 ARCHIVE_SOURCE:=$(APPNAME)-$(VERSION).tar.gz
-ARCHIVE_WIN32:=$(APPNAME)-$(VERSION).exe
+ARCHIVE_WHEEL:=$(APPNAME)-$(VERSION)-py2.py3-none-any.whl
 GITUSER:=wummel
 GITREPO:=$(APPNAME)
 HOMEPAGE:=$(HOME)/public_html/patool-webpage.git
 WEBMETA:=doc/web/app.yaml
-DEBUILDDIR:=$(HOME)/projects/debian/official
-DEBORIGFILE:=$(DEBUILDDIR)/$(APPNAME)_$(VERSION).orig.tar.gz
-DEBPACKAGEDIR:=$(DEBUILDDIR)/$(APPNAME)-$(VERSION)
 # Pytest options:
 # --resultlog: write test results in file
 # -s: do not capture stdout/stderr (some tests fail otherwise)
@@ -27,22 +24,16 @@
 
 dist:
 	[ -d dist ] || mkdir dist
-	$(PYTHON) setup.py sdist --formats=tar
+	$(PYTHON) setup.py sdist --formats=tar bdist_wheel
 	gzip --best dist/$(APPNAME)-$(VERSION).tar
-	[ ! -f ../$(ARCHIVE_WIN32) ] || cp ../$(ARCHIVE_WIN32) dist
 
 sign:
 	[ -f dist/$(ARCHIVE_SOURCE).asc ] || gpg --detach-sign --armor dist/$(ARCHIVE_SOURCE)
-	[ -f dist/$(ARCHIVE_WIN32).asc ] || gpg --detach-sign --armor dist/$(ARCHIVE_WIN32)
+	[ -f dist/$(ARCHIVE_WHEEL).asc ] || gpg --detach-sign --armor dist/$(ARCHIVE_WHEEL)
 
-upload:	upload_source upload_binary
-
-upload_source:
-	twine upload dist/$(ARCHIVE_SOURCE) dist/$(ARCHIVE_SOURCE).asc
-
-upload_binary:
-	cp dist/$(ARCHIVE_WIN32) dist/$(ARCHIVE_WIN32).asc \
-	  $(HOMEPAGE)/dist
+upload:
+	twine upload dist/$(ARCHIVE_SOURCE) dist/$(ARCHIVE_SOURCE).asc \
+	             dist/$(ARCHIVE_WHEEL) dist/$(ARCHIVE_WHEEL).asc
 
 update_webmeta:
 # update metadata
@@ -66,7 +57,7 @@
 # Each step is a separate target so that it's easy to do this manually if
 # anything screwed up.
 release: distclean releasecheck
-	$(MAKE) dist sign upload homepage tag register changelog deb
+	$(MAKE) dist sign upload homepage tag register changelog
 
 register:
 	@echo "Register at Python Package Index..."
@@ -76,9 +67,10 @@
 	@if egrep -i "xx\.|xxxx|\.xx" doc/changelog.txt > /dev/null; then \
 	  echo "Could not release: edit doc/changelog.txt release date"; false; \
 	fi
-	@if [ ! -f ../$(ARCHIVE_WIN32) ]; then \
-	  echo "Missing WIN32 distribution archive at ../$(ARCHIVE_WIN32)"; \
-	  false; \
+	@if ! head -n1 doc/changelog.txt | egrep "^$(VERSION)" >/dev/null; then \
+	  echo "Could not release: different versions in doc/changelog.txt and setup.py"; \
+	  echo "Version in doc/changelog.txt:"; head -n1 doc/changelog.txt; \
+	  echo "Version in setup.py: $(VERSION)"; false; \
 	fi
 	$(PYTHON) setup.py check --restructuredtext
 
@@ -123,21 +115,8 @@
 	$(PYTHON) -m pytest $(PYTESTOPTS) $(TESTOPTS) $(TESTS)
 
 doc/$(APPNAME).txt: doc/$(APPNAME).1
-# make text file from man page for Windows builds
+# make text file from man page for wheel builds
 	cols=`stty size | cut -d" " -f2`; stty cols 72; man -l $< | sed -e 's/.\cH//g' > $@; stty cols $$cols
-
-deb:
-# build a debian package
-	[ -f $(DEBORIGFILE) ] || cp dist/$(ARCHIVE_SOURCE) $(DEBORIGFILE)
-	sed -i -e 's/VERSION_$(APPNAME):=.*/VERSION_$(LAPPNAME):=$(VERSION)/' $(DEBUILDDIR)/$(LAPPNAME).mak
-	[ -d $(DEBPACKAGEDIR) ] || (cd $(DEBUILDDIR); \
-	  patool extract $(DEBORIGFILE); \
-	  cd $(CURDIR); \
-	  git checkout debian; \
-	  cp -r debian $(DEBPACKAGEDIR); \
-	  rm -f $(DEBPACKAGEDIR)/debian/.gitignore; \
-	  git checkout master)
-	$(MAKE) -C $(DEBUILDDIR) $(APPNAME)_clean $(APPNAME)
 
 update-copyright:
 # update-copyright is a local tool which updates the copyright year for each
@@ -149,6 +128,6 @@
 # closes issues mentioned in the changelog entries.
 	github-changelog $(DRYRUN) $(GITUSER) $(GITREPO) doc/changelog.txt
 
-.PHONY: changelog update-copyright deb test clean count pyflakes check
+.PHONY: changelog update-copyright test clean count pyflakes check
 .PHONY: releasecheck release upload sign dist all tag register homepage
 .PHONY: localbuild doccheck

=== debian/changelog ===
patool (1.10-1) unstable; urgency=low

  * New upstream release.
     + override test suites (Closes: #805219)
     + new build-depends python-setuptools
     + bash-completion to /usr/share/bash-completions/completions/
     + cleaned debian/rules
     + deleted pycompact,since they are obsolete

 -- Abhijith PA <abhijith@openmailbox.org>  Sat, 12 Dec 2015 22:08:25 +0530

patool (1.8-1) unstable; urgency=medium

  * New maintainer (Closes: #774997)
  * New upstream release.
  * Changed debian/rules.
  * Deleted debian/patool.docs
  * Changed debian/control
     + Added new build depends,bash-completion and dh-python
     + Removed some suggested packages since they were orphaned
     + VCS field added 
  * debian/patches
     + Adding to patch suppress lintian info  

 -- Abhijith PA <abhijith@openmailbox.org>  Mon, 17 Aug 2015 17:30:43 +0530

=== debian/control ===
Source: patool
Maintainer: Abhijith PA <abhijith@openmailbox.org>
Section: utils
Priority: optional
Build-Depends: python-all (>= 2.7),
               debhelper (>= 9),
               dh-python ,
               bash-completion,
               python-setuptools
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/patool.git
Vcs-Git: git://anonscm.debian.org/collab-maint/patool.git
Homepage: http://wummel.github.io/patool/
X-Python-Version: >= 2.7

Package: patool
Architecture: all
Depends: ${python:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: file
Suggests: arj,
          bzip2 | lbzip2 | pbzip2,
          cabextract | lcab,
          ncompress,
          cpio | bsdcpio,
          lzop,
          p7zip-full,
          rar | unrar | zip | unzip,
          rpm2cpio,
          binutils,
          lha,
          unace | unace-nonfree | nomarch,
          unalz,
          lrzip (>= 0.551),
          tar (>= 1.26) | bsdtar,
          xdms,
          orange,
          lzip | plzip | clzip | pdlzip,
          sharutils,
          flac,
          archmage,
          genisoimage,
          python-argcomplete
Provides: ${python:Provides}
Description: command line archive file manager
 Various archive formats can be created, extracted, tested, listed,
 compared, searched and repacked by patool. The archive format is
 determined with file and as a fallback by the archive file extension.
 .
 patool supports 7z (.7z), ACE (.ace), ADF (.adf), ALZIP (.alz), AR (.a),
 ARC (.arc), ARJ (.arj), BZIP2 (.bz2), CAB (.cab), compress (.Z), CPIO (.cpio),
 DEB (.deb), DMS (.dms), FLAC (.flac), GZIP (.gz), ISO (.iso), LZH (.lha, .lzh),
 LZIP (.lz), LZMA (.lzma), LZOP (.lzo), RAR (.rar), RPM (.rpm), RZIP (.rz),
 SHAR (.shar), SHN (.shn), TAR (.tar), XZ (.xz), ZIP (.zip, .jar) and
 ZOO (.zoo) formats.
 .
 It relies on helper applications to handle those archive formats
 (for example bzip2 for BZIP2 archives).
 .
 The archive formats TAR, ZIP, BZIP2 and GZIP
 are supported natively and do not require helper applications to be
 installed.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=patool

%:
	dh $@ --with python2,bash-completion --buildsystem=pybuild

override_dh_auto_build:
# force usage of setup.py over Makefile
	dh_auto_build

override_dh_auto_clean:
	dh_auto_clean
	rm -rf _patool_configdata.py

# do not run test suite when building
override_dh_auto_test:

override_dh_installchangelogs:
# install custom changelog
	dh_installchangelogs doc/changelog.txt

override_dh_install:
	dh_install
# install bash_completion script
	install -m 644 patool.bash-completion $(CURDIR)/debian/patool/usr/share/bash-completion/completions/patool

=== debian/watch ===
version=3
http://wummel.github.io/patool/ \
(?:|.*/)patool(?:[_\-]v?|)(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)

## patool 1.12

=== Makefile ===
--- 
+++ 
@@ -77,7 +77,7 @@
 check:
 # The check programs used here are mostly local scripts on my private system.
 # So for other developers there is no need to execute this target.
-	check-copyright
+	check-copyright setup.py patool patoolib tests
 	check-pofiles -v
 	py-tabdaddy
 	py-unittest2-compat tests/

=== debian/changelog ===
patool (1.12-5) unstable; urgency=medium

  * Bump Standards-Version
  * Use debhelper-compat instead

 -- Abhijith PA <abhijith@debian.org>  Sun, 16 Feb 2020 20:00:26 +0530

patool (1.12-4) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/control: Remove ancient X-Python-Version field
  * d/copyright: Use https protocol in Format field
  * d/changelog: Remove trailing whitespaces
  * d/control: Set Vcs-* to salsa.debian.org

  [ Abhijith PA ]
  * Enable autopkgtest
  * d/control:
     + Change maintainer email address
     + Remove python-all, python2, Python: Depends (Closes: #937249)
     + Remove bsdcpio, bsdtar and add libarchivetools to
       Suggests (Closes: #917425)
     + Add lhasa to Suggests
     + Bumps Standard-Versions to 4.4.1
     + Remove X-Python3-Version, Testsuite field
     + Add Rules-Requires-Root: no
     + Bumps debhelper version to 12
  * Add salsa-ci file.
  * Rewrite dh_clean in rules

 -- Abhijith PA <abhijith@debian.org>  Mon, 01 Oct 2018 10:06:47 +0200

patool (1.12-3) unstable; urgency=low

  * Re-upload to unstable

 -- Abhijith PA <abhijith@openmailbox.org>  Mon, 10 Oct 2016 09:01:42 +0530

patool (1.12-2) experimental; urgency=low

  * Adds python3 support for patoolib (closes: #833880)

 -- Abhijith PA <abhijith@openmailbox.org>  Sun, 11 Sep 2016 16:20:56 +0530

patool (1.12-1) unstable; urgency=low

  * New upstream release.
  * Delete patool.dirs , No longer needed
  * Adds patool.bash-completion in debian/ Thanks to bignose
  * Change debian/rules
     + Removed manually installing bash-completion files (closes: #815815)
  * Change debian/control
     + bumps Standard-Version to 3.9.8
     + Vcs-git field change from git:// to https://

 -- Abhijith PA <abhijith@openmailbox.org>  Mon, 16 May 2016 20:38:12 +0530

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,21 @@
 Source: patool
-Maintainer: Abhijith PA <abhijith@openmailbox.org>
+Maintainer: Abhijith PA <abhijith@debian.org>
 Section: utils
 Priority: optional
-Build-Depends: python-all (>= 2.7),
-               debhelper (>= 9),
+Build-Depends: debhelper-compat (= 12),
                dh-python ,
                bash-completion,
-               python-setuptools
-Standards-Version: 3.9.6
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/patool.git
-Vcs-Git: git://anonscm.debian.org/collab-maint/patool.git
+               python3-all (>= 3.5),
+               python3-setuptools
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
+Vcs-Browser: https://salsa.debian.org/debian/patool
+Vcs-Git: https://salsa.debian.org/debian/patool.git
 Homepage: http://wummel.github.io/patool/
-X-Python-Version: >= 2.7
 
 Package: patool
 Architecture: all
-Depends: ${python:Depends},
+Depends: ${python3:Depends},
          ${shlibs:Depends},
          ${misc:Depends}
 Recommends: file
@@ -23,8 +23,7 @@
           bzip2 | lbzip2 | pbzip2,
           cabextract | lcab,
           ncompress,
-          cpio | bsdcpio,
-          lzop,
+          cpio, lzop,
           p7zip-full,
           rar | unrar | zip | unzip,
           rpm2cpio,
@@ -33,12 +32,14 @@
           unace | unace-nonfree | nomarch,
           unalz,
           lrzip (>= 0.551),
-          tar (>= 1.26) | bsdtar,
+          lhasa,
+          tar (>= 1.26),
           xdms,
           orange,
           lzip | plzip | clzip | pdlzip,
           sharutils,
           flac,
+          libarchive-tools,
           archmage,
           genisoimage,
           python-argcomplete

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=patool

%:
	dh $@ --with python3,bash-completion --buildsystem=pybuild

override_dh_auto_build:
# force usage of setup.py over Makefile
	dh_auto_build

override_dh_clean:
	rm -rf _patool_configdata.py
	dh_clean

# do not run test suite when building
override_dh_auto_test:

override_dh_installchangelogs:
# install custom changelog
	dh_installchangelogs doc/changelog.txt

override_dh_install:
	dh_install

=== debian/watch ===
version=3
https://wummel.github.io/patool/ \
(?:|.*/)patool(?:[_\-]v?|)(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)

## patool 2.0.0

=== Makefile ===
# This Makefile is only used by developers.

############# Settings ############
# use Bash as shell, not sh
SHELL := bash
# execute makefile in a single bash process instead of one per target
.ONESHELL:
# set Bash flags
.SHELLFLAGS := -eu -o pipefail -c
# remove target files if a rule fails, forces reruns of aborted rules
.DELETE_ON_ERROR:
# warn for undefined variables
MAKEFLAGS += --warn-undefined-variables
# disable builtin default rules
MAKEFLAGS += --no-builtin-rules


############ Configuration ############
VERSION:=$(shell grep "Version =" patoolib/configuration.py | cut -d '"' -f2)
AUTHOR:=$(shell grep "MyName =" patoolib/configuration.py | cut -d '"' -f2)
APPNAME:=$(shell grep "AppName =" patoolib/configuration.py | cut -d '"' -f2)
ARCHIVE_SOURCE:=$(APPNAME)-$(VERSION).tar.gz
ARCHIVE_WHEEL:=$(APPNAME)-$(VERSION)-py2.py3-none-any.whl
GITUSER:=wummel
GITREPO:=$(APPNAME)
HOMEPAGE:=$(HOME)/public_html/patool-webpage.git
WEBMETA:=doc/web/source/conf.py
CHANGELOG:=doc/changelog.txt
PIP_VERSION:=23.3.1
# Pytest options:
# -s: do not capture stdout/stderr (some tests fail otherwise)
# --full-trace: print full stacktrace on keyboard interrupts
PYTESTOPTS?=-s --full-trace
# which test modules to run
TESTS ?= tests/
# set test options
TESTOPTS=

############ Default target ############

.PHONY: help
help:	## display this help section
	@awk 'BEGIN {FS = ":.*?## "} /^[a-zA-Z0-9_-]+:.*?## / {printf "\033[36m%-38s\033[0m %s\n", $$1, $$2}' $(MAKEFILE_LIST)
.DEFAULT_GOAL := help


############ Installation and provisioning  ############

.PHONY: init
init:	requirements-dev.txt
	pip install --upgrade pip==$(PIP_VERSION)
	pip install -r $<

.PHONY: localbuild
localbuild:
	pip install --editable .


############ Build and release targets ############

.PHONY: clean
clean:
	python setup.py clean --all
	pip uninstall --yes patool
	$(MAKE) -C doc/web clean

.PHONY: distclean
distclean:	clean
	rm -rf build dist $(APPNAME).egg-info
	rm -f MANIFEST
# clean aborted dist builds and output files
	rm -f testresults.txt
	rm -rf $(APPNAME)-$(VERSION)
	rm -f *-stamp*

.PHONY: dist
dist:
	python setup.py sdist bdist_wheel

.PHONY: upload
upload:
	twine upload --config-file $(XDG_CONFIG_HOME)/pypirc \
	  dist/$(ARCHIVE_SOURCE) dist/$(ARCHIVE_WHEEL)

.PHONY: tag
tag:
# add and push the version tag
	git tag upstream/$(VERSION)
	git push --tags origin upstream/$(VERSION)

# Make a new release by calling all the distinct steps in the correct order.
# Each step is a separate target so that it's easy to do this manually if
# anything screwed up.
.PHONY: release
release: distclean releasecheck
	$(MAKE) dist upload homepage tag github-issues

.PHONY: releasecheck
releasecheck: checkgit checkchangelog lint test

checkgit:
# check that branch is master
	@if [ "$(shell git rev-parse --abbrev-ref HEAD)" != "master" ]; then \
	  echo "ERROR: current branch is not 'master'"; \
	  git rev-parse --abbrev-ref HEAD; \
	  false; \
	fi
# check for uncommitted versions
	@if [ -n "$(shell git status --porcelain --untracked-files=all)" ]; then \
	  echo "ERROR: uncommitted changes"; \
	  git status --porcelain --untracked-files=all; \
	  false; \
	fi

github-issues:
# github-changelog is a local tool which parses the changelog and automatically
# closes issues mentioned in the changelog entries.
	cd .. && github-changelog $(DRYRUN) $(GITUSER) $(GITREPO) patool.git/doc/changelog.txt


############ Versioning ############

# shortcut target for bumpversion: bumpversion-{major,minor,patch}
bumpversion-%:
	bumpversion $*
	$(MAKE) bumpchangelog

bumpchangelog:
	sed -i '1i$(VERSION) (released xx.xx.xxxx)\n  *\n' $(CHANGELOG)

# check changelog before release
checkchangelog:
	@if egrep -i "xx\.|xxxx|\.xx" $(CHANGELOG) > /dev/null; then \
	  echo "Could not release: edit $(CHANGELOG) release date"; false; \
	fi
	@if ! grep "^$(VERSION)" $(CHANGELOG) > /dev/null; then \
	  echo "ERROR: Version $(VERSION) missing from $(CHANGELOG)"; \
	  false; \
	fi
	@if ! head -n1 $(CHANGELOG) | egrep "^$(VERSION)" >/dev/null; then \
	  echo "Could not release: different versions in $(CHANGELOG) and setup.py"; \
	  echo "Version in $(CHANGELOG):"; head -n1 $(CHANGELOG); \
	  echo "Version in setup.py: $(VERSION)"; false; \
	fi


############ Linting and syntax checks ############

.PHONY: lint
lint:
	ruff setup.py patoolib tests

.PHONY: reformat
reformat:
	ruff --fix setup.py patoolib tests

.PHONY: checkoutdated
checkoutdated:
	pip list --format=columns --outdated


############ Testing ############

.PHONY: test
test:
	pytest $(PYTESTOPTS) $(TESTOPTS) $(TESTS)


############ Documentation ############

doc/$(APPNAME).txt: doc/$(APPNAME).1
# make text file from man page for wheel builds
	cols=`stty size | cut -d" " -f2`; stty cols 72; man -l $< | sed -e 's/.\cH//g' > $@; stty cols $$cols

.PHONY: count
count:
# print some code statistics
	@sloccount patoolib

.PHONY: update_webmeta
update_webmeta:
# update metadata
	sed -i -e 's/project =.*/project = "$(APPNAME)"/g' $(WEBMETA)
	sed -i -e 's/version =.*/version = "$(VERSION)"/g' $(WEBMETA)
	sed -i -e 's/author =.*/author = "$(AUTHOR)"/g' $(WEBMETA)

.PHONY: homepage
homepage: update_webmeta
# release website
	$(MAKE) -C doc/web release

=== debian/changelog ===
patool (2.0.0-2) unstable; urgency=medium

  * Remove upstream tests/ in autopkgtest

 -- Abhijith PA <abhijith@debian.org>  Thu, 25 Jan 2024 14:34:54 +0530

patool (2.0.0-1) unstable; urgency=medium

  [ Janitor ]
  * d/control: Update with https URI for Homepage field
  * d/rules: Remove override_dh_auto_build and override_dh_install

  [ Abhijith PA ]
  * New upstream release
  * d/patches:
     + Remove hyphen.patch. Fixed in upstream
     + Add 01-skip-a-test-in-isoinfo.patch to skip a test
  * d/control:
     + Bump Standards-Version to 4.6.2
     + Update suggests packages.
     + Remove Provides field and ${shlibs:Depends} substitution
       variables
  * d/rules: Add dh_installman to install manpage for patool
  * Add a lintian override
  * update gitlab-ci.yml
  * Run upstream tests/ in autopkgtest

 -- Abhijith PA <abhijith@debian.org>  Mon, 20 Nov 2023 13:04:59 +0530

=== debian/control ===
--- 
+++ 
@@ -2,21 +2,20 @@
 Maintainer: Abhijith PA <abhijith@debian.org>
 Section: utils
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
-               dh-python ,
+Build-Depends: debhelper-compat (= 13),
+               dh-python,
                bash-completion,
                python3-all (>= 3.5),
                python3-setuptools
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/patool
 Vcs-Git: https://salsa.debian.org/debian/patool.git
-Homepage: http://wummel.github.io/patool/
+Homepage: https://wummel.github.io/patool/
 
 Package: patool
 Architecture: all
 Depends: ${python3:Depends},
-         ${shlibs:Depends},
          ${misc:Depends}
 Recommends: file
 Suggests: arj,
@@ -28,22 +27,19 @@
           rar | unrar | zip | unzip,
           rpm2cpio,
           binutils,
-          lha,
           unace | unace-nonfree | nomarch,
           unalz,
           lrzip (>= 0.551),
           lhasa,
           tar (>= 1.26),
           xdms,
-          orange,
           lzip | plzip | clzip | pdlzip,
           sharutils,
           flac,
           libarchive-tools,
           archmage,
           genisoimage,
-          python-argcomplete
-Provides: ${python:Provides}
+          python3-argcomplete
 Description: command line archive file manager
  Various archive formats can be created, extracted, tested, listed,
  compared, searched and repacked by patool. The archive format is

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=patool

%:
	dh $@ --with python3,bash-completion --buildsystem=pybuild

override_dh_clean:
	rm -rf _patool_configdata.py
	dh_clean

# do not run test suite when building
override_dh_auto_test:

override_dh_installchangelogs:
# install custom changelog
	dh_installchangelogs doc/changelog.txt
	dh_installman doc/patool.1

## patool 3.1.0

=== debian/changelog ===
patool (3.1.0-2) unstable; urgency=medium

  * Source only upload for migration to testing

 -- Abhijith PA <abhijith@debian.org>  Tue, 11 Feb 2025 13:01:28 +0530

patool (3.1.0-1) unstable; urgency=medium

  * New upstream release.
  * Delete 01-skip-a-test-in-isoinfo.patch . We only run patool test.
  * d/rules: Disable archive/ tests. Only run patool test
  * d/control:
    + Add python3-pytest to Build-depends.
    + Bump Standards-Version to 4.7.0
    + Use 7zip instead of P7zip-full in `Suggests` (Closes: #1063594)
  * d/watch: upgrade version to 4.

 -- Abhijith PA <abhijith@debian.org>  Wed, 05 Feb 2025 16:24:03 +0530

## patool 3.1.3

=== debian/changelog ===
patool (3.1.3-1) unstable; urgency=medium

  * New upstream release.

 -- Abhijith PA <abhijith@debian.org>  Mon, 24 Feb 2025 15:41:12 +0530

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,9 @@
                dh-python,
                bash-completion,
                python3-all (>= 3.5),
-               python3-setuptools
-Standards-Version: 4.6.2
+               python3-setuptools,
+               python3-pytest
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/patool
 Vcs-Git: https://salsa.debian.org/debian/patool.git
@@ -22,8 +23,7 @@
           bzip2 | lbzip2 | pbzip2,
           cabextract | lcab,
           ncompress,
-          cpio, lzop,
-          p7zip-full,
+          cpio, lzop, 7zip,
           rar | unrar | zip | unzip,
           rpm2cpio,
           binutils,

## patool 4.0.0

=== Makefile ===
# This Makefile is only used by developers.

############# Settings ############
# use Bash as shell, not sh
SHELL := bash
# execute makefile in a single bash process instead of one per target
.ONESHELL:
# set Bash flags
.SHELLFLAGS := -eu -o pipefail -c
# remove target files if a rule fails, forces reruns of aborted rules
.DELETE_ON_ERROR:
# warn for undefined variables
MAKEFLAGS += --warn-undefined-variables
# disable builtin default rules
MAKEFLAGS += --no-builtin-rules


############ Configuration ############
VERSION:=$(shell grep "Version: str =" patoolib/configuration.py | cut -d '"' -f2)
AUTHOR:=$(shell grep "MyName: str =" patoolib/configuration.py | cut -d '"' -f2)
APPNAME:=$(shell grep "AppName: str =" patoolib/configuration.py | cut -d '"' -f2)
ARCHIVE_SOURCE:=$(APPNAME)-$(VERSION).tar.gz
ARCHIVE_WHEEL:=$(APPNAME)-$(VERSION)-py2.py3-none-any.whl
GITRELEASETAG:=$(VERSION)
GITUSER:=wummel
GITREPO:=$(APPNAME)
HOMEPAGE:=$(HOME)/public_html/patool-webpage.git
WEBMETA:=doc/web/source/conf.py
CHANGELOG:=doc/changelog.txt
GIT_MAIN_BRANCH:=master
# Pytest options:
# -s: do not capture stdout/stderr (some tests fail otherwise)
# --full-trace: print full stacktrace on keyboard interrupts
# --log-file: write test output to file for easier inspection
# --numprocesses auto: run tests in parallel on available CPU cores (uses pytest-xdist) 
PYTESTOPTS?=-s --full-trace --log-file=build/test.log --numprocesses auto
# which test modules to run
TESTS ?= tests/
# set test options
TESTOPTS=

############ Default target ############

# `make help` displays all targets documented with `##`in the target line
.PHONY: help
help:	## display this help section
	@awk 'BEGIN {FS = ":.*?## "} /^[a-zA-Z0-9_-]+:.*?## / {printf "\033[36m%-38s\033[0m %s\n", $$1, $$2}' $(MAKEFILE_LIST)
.DEFAULT_GOAL := help


############ Installation and provisioning  ############

# these targets work best in a virtual python environment
# see https://github.com/pyenv/pyenv for more info

.PHONY: init ## install python virtual env and required development packages
init:
	uv sync


############ Build and release targets ############

.PHONY: clean
clean: ## remove generated python, web page files and all local patool installations
	python setup.py clean --all
	uv pip uninstall patool
	$(MAKE) -C doc/web clean

.PHONY: distclean
distclean:	clean ## run clean and additionally remove all build and dist files
	rm -rf build dist
	rm -f MANIFEST
# clean aborted dist builds and output files
	rm -rf $(APPNAME)-$(VERSION) $(APPNAME).egg-info
	rm -f *-stamp*

.PHONY: dist
dist: ## build source and wheel distribution file
	uv build

.PHONY: release-pypi
release-pypi: ## upload a new release to pypi
	uv publish dist/$(ARCHIVE_SOURCE) dist/$(ARCHIVE_WHEEL)

# export GITHUB_TOKEN for the hub command
# Generate a fine grained access token with:
# - Restricted to this repository (patool)
# - Repository permission: Metadata -> Read (displayed as "Read access to metadata" in token view)
# - Repository permission: Contents -> Read and write (displayed as "Read and Write access to code" in token view)
# - Expiration in 90 days
# After that run "export GITHUB_TOKEN=<token-content>"
.PHONY: release-gh
release-gh:	## upload a new release to github
	gh release create \
	  --title "Release $(GITRELEASETAG)" \
	  --notes "See doc/changelog.txt for release notes" \
	  --latest \
	  --draft=false \
	  --prerelease=false \
	  --verify-tag  \
	  "$(GITRELEASETAG)" \
	  dist/$(ARCHIVE_SOURCE) \
	  dist/$(ARCHIVE_WHEEL)


# Make a new release by calling all the distinct steps in the correct order.
# Each step is a separate target so that it's easy to do this manually if
# anything screwed up.
.PHONY: release
release: distclean releasecheck ## release a new version of patool
	$(MAKE) dist release-gh release-pypi release-homepage github-issues

.PHONY: releasecheck
releasecheck: update_webmeta checkgit checkchangelog lint test typecheck checkgitreleasetag ## check that repo is ready for release

.PHONY: checkgit
checkgit: ## check that git changes are all committed on the main branch
# check that branch is the main branch
	@if [ "$(shell git rev-parse --abbrev-ref HEAD)" != "$(GIT_MAIN_BRANCH)" ]; then \
	  echo "ERROR: current git branch is not '$(GIT_MAIN_BRANCH)'"; \
	  git rev-parse --abbrev-ref HEAD; \
	  false; \
	fi
# check for uncommitted versions
	@if [ -n "$(shell git status --porcelain --untracked-files=all)" ]; then \
	  echo "ERROR: uncommitted git changes"; \
	  git status --porcelain --untracked-files=all; \
	  false; \
	fi

.PHONY: checkgitreleasetag
checkgitreleasetag:	## check release tag for git exists
	@if [ -z "$(shell git tag -l -- $(GITRELEASETAG))" ]; then \
	  echo "ERROR: git tag \"$(GITRELEASETAG)\" does not exist, execute 'git tag -a $(GITRELEASETAG) -m \"$(GITRELEASETAG)\"'"; \
	  false; \
	fi
# check that release tags is pushed to remote
	@if ! git ls-remote --exit-code --tags origin $(GITRELEASETAG); then \
	  echo "ERROR: git tag \"$(GITRELEASETAG)\" does not exist on remote repo, execute 'git push --tags'"; \
	fi

.PHONY: github-issues
github-issues: ## close github issues mentioned in changelog
# github-changelog is a local tool which parses the changelog and automatically
# closes issues mentioned in the changelog entries.
	cd .. && github-changelog $(GITUSER) $(GITREPO) patool.git/doc/changelog.txt


############ Versioning ############

bumpversion-%: ## shortcut target for bumpversion: bumpversion-{major,minor,patch}
	bumpversion $*
	$(MAKE) bumpchangelog

bumpchangelog: ## add leading changelog entry for a new version
	sed -i '1i$(VERSION) (released xx.xx.xxxx)\n  *\n' $(CHANGELOG)


checkchangelog: ## check changelog before release
	@if egrep -i "xx\.|xxxx|\.xx" $(CHANGELOG) > /dev/null; then \
	  echo "Could not release: edit $(CHANGELOG) release date"; false; \
	fi
	@if ! grep "^$(VERSION)" $(CHANGELOG) > /dev/null; then \
	  echo "ERROR: Version $(VERSION) missing from $(CHANGELOG)"; \
	  false; \
	fi
	@if ! head -n1 $(CHANGELOG) | egrep "^$(VERSION)" >/dev/null; then \
	  echo "Could not release: different versions in $(CHANGELOG) and setup.py"; \
	  echo "Version in $(CHANGELOG):"; head -n1 $(CHANGELOG); \
	  echo "Version in setup.py: $(VERSION)"; false; \
	fi


############ Linting and syntax checks ############

.PHONY: lint
lint: ## lint python code
	ruff check setup.py patoolib tests doc/web/source

.PHONY: reformat
reformat: ## format the python code
	ruff format setup.py patoolib tests doc/web/source

.PHONY: checkoutdated checkoutdatedpy checkoutdatedgh
checkoutdated: checkoutdatedpy checkoutdatedgh

checkoutdatedpy:	## Check for outdated package requirements
# Compare the list of currently installed packages with the same list of packages with latest versions from pypi.
# Assumes that all requirements have pinned versions with "==".
# To check only direct dependencies, not those of further down the dependency tree,
# the output is filtered by using `pip tree -d0` and grep with a regular
# expression of the form
# `grep -E "(\tpackage1\t|package2\t| ... |\tpackageN)"`.
# The leading tab before each package prevents matching substrings.
# When grep does not find any match, all required packages are uptodate.
# In this case, grep exits with exitcode 1. Test for this after running grep.
	@set +e; \
	echo "Check for outdated Python packages"; \
	uv pip list --format=freeze |sed 's/==.*//' | uv pip compile - --color=never --quiet --no-deps --no-header --no-annotate |diff <(uv pip list --format=freeze) - --side-by-side --suppress-common-lines | \
	grep -iE "($(shell grep == pyproject.toml  | cut -f1 -d= | tr -d "\"\' "| sed -e 's/\[.*\]//' |sort | paste -sd '|'))"; \
	test $$? = 1

checkoutdatedgh:	## check for outedated github tools
# github-check-outdated is a local tool which compares a given version with the latest available github release version
# see https://gist.github.com/wummel/ef14989766009effa4e262b01096fc8c for an example implementation
	@echo "Check for outdated Github tools"
	github-check-outdated astral-sh uv "$(shell uv version | cut -f2 -d" ")"


############ Testing ############

.PHONY: test
test: ## run tests
	uv run pytest $(PYTESTOPTS) $(TESTOPTS) $(TESTS)

# Needs https://nektosact.com/ and docker
# Uses https://github.com/catthehacker/docker_images
.PHONY: test-github
test-github: ## run github workflow actions
	act -P ubuntu-latest=ghcr.io/catthehacker/ubuntu:act-latest --matrix os:ubuntu-latest

.PHONY: typecheck
typecheck:	## run pytype
	pytype patoolib

############ Documentation ############

doc/$(APPNAME).txt: doc/$(APPNAME).1 ## make text file from man page for wheel builds
	cols=`stty size | cut -d" " -f2`; stty cols 72; man -l $< | sed -e 's/.\cH//g' > $@; stty cols $$cols

.PHONY: count
count: ## print some code statistics
	@sloccount patoolib

.PHONY: update_webmeta
update_webmeta: ## update package metadata for the homepage
	sed -i -e 's/project =.*/project = "$(APPNAME)"/g' $(WEBMETA)
	sed -i -e 's/version =.*/version = "$(VERSION)"/g' $(WEBMETA)
	sed -i -e 's/author =.*/author = "$(AUTHOR)"/g' $(WEBMETA)

.PHONY: release-homepage
release-homepage: update_webmeta ## update the homepage after a release
	$(MAKE) -C doc/web release

=== debian/changelog ===
patool (4.0.0-1) unstable; urgency=medium

  * New upstream release.

 -- Abhijith PA <abhijith@debian.org>  Fri, 21 Mar 2025 11:12:05 +0530

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper-compat (= 13),
                dh-python,
                bash-completion,
-               python3-all (>= 3.5),
+               python3-all (>= 3.11),
                python3-setuptools,
                python3-pytest
 Standards-Version: 4.7.0

## patool 4.0.1

=== Makefile ===
--- 
+++ 
@@ -204,7 +204,7 @@
 # github-check-outdated is a local tool which compares a given version with the latest available github release version
 # see https://gist.github.com/wummel/ef14989766009effa4e262b01096fc8c for an example implementation
 	@echo "Check for outdated Github tools"
-	github-check-outdated astral-sh uv "$(shell uv version | cut -f2 -d" ")"
+	github-check-outdated astral-sh uv "$(shell uv self version | cut -f2 -d" ")"
 
 
 ############ Testing ############

=== debian/changelog ===
patool (4.0.1-1) unstable; urgency=medium

  * New upstream release.

 -- Abhijith PA <abhijith@debian.org>  Wed, 27 Aug 2025 10:19:52 +0530

=== debian/watch ===
version=4
https://wummel.github.io/patool/ \
(?:|.*/)patool(?:[_\-]v?|)(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
